#ifdef __DJ_size_t
#define _SIZE_T
#endif
#ifndef _SIZE_T
#define tttcfull		/* Kind of bad test... */
#endif

#ifndef tttobj_def
#define tttobj_def
#include <vector>
#include <string>

using namespace std;
class tttobj
{
public:
	int id;
	string to, text;
	tttobj(const int ID,const char *TO,const char *TEXT)
	:	id(ID), to(TO), text(TEXT)
	{
	}
};
typedef vector <tttobj> tttlist;

extern const tttobj &DoQuery(const tttlist &s);
extern bool TTTDead(void);

#endif

#ifdef tttcfull
class ttthelper
{
public:
	string key;
	tttobj obj;
	ttthelper(const string &k, int id, const char *dest,
	          const char *text):key(k),obj(id,dest,text)
	{
	}
};
typedef vector<ttthelper> tttentry;
static void add(tttentry &e, const char *key, int id,
                const char *dest, const char *text)
{
	e.insert(e.end(), ttthelper(key, id, dest, text));
}
#else
extern
#endif

void d2_ttt(void)
#ifdef tttcfull
{
	tttentry selections;
	string ThisPos="S";

	add(selections, "S", 0, "a1", "gruu.");
	add(selections, "S", 0, "Q", "atshiih");
	add(selections, "S", 0, "Q", "tshhiih");
	add(selections, "S", 0, "Q", "atshiuh\nsniff");
	add(selections, "S", 0, "a4", "hmm");
	add(selections, "a1", 1, "b1", "gruu.");
	add(selections, "a1", 1, "b2", "gruu...");
	add(selections, "a1", 1, "b3", "gruu?");
	add(selections, "a4", 1, "b4", "hmm.");
	add(selections, "b1", 0, "e", "bhum hum");
	add(selections, "b2", 0, "e", "gruu...");
	add(selections, "b3", 0, "e", "gruu.");
	add(selections, "b4", 0, "e", "hhh");
	add(selections, "e", 1, "Q", "purr");
	add(selections, "e", 1, "Q", "kaunis piv tnn jne :)");
	add(selections, "e", 1, "Q", "d0h.");
	add(selections, "e", 1, "Q", ".. ja joulu tulee...");
	add(selections, "e", 1, "Q", ".. ja kes tulee...");
	add(selections, "e", 1, "f", "joh");
	add(selections, "f", 0, "Q", "ei mitn :)");
	add(selections, "e", 1, "Q", "ACTION vaikenee.");
	// warpman-jutut
	add(selections, "S", 0, "a5", "*fart*");
	add(selections, "a5", 1, "b5", ".... niin mik?");
	add(selections, "S", 0, "a6", "sur");
	add(selections, "S", 0, "a6", "pepsi...");
	add(selections, "b5", 0, "a6", "fart. selv fart.");
	add(selections, "b5", 0, "a6", "sellanen fart.");
	add(selections, "a6", 1, "b6", "l viitti warpmaneilla.");
	add(selections, "a6", 1, "b6", "argh. lopeta warpmanismi");
	add(selections, "a6", 1, "Q", "pl. ei warpman-vitsej kiitos");
	add(selections, "a6", 1, "b6", "blah. jt pois noi.");
	add(selections, "a6", 1, "b6", "eih");
	add(selections, "b6", 0, "Q", "ok...");
	add(selections, "b6", 0, "Q", "selv...");
	add(selections, "b6", 0, "Q", "ACTION vaikenee.");

	int id=0;

	while(ThisPos != "Q" && !TTTDead())
	{
		bool idset=false; tttlist l; tttentry::const_iterator i;

		for(i=selections.begin(); i!=selections.end(); i++)
			if(i->key==ThisPos)
			{
				if(idset && id != i->obj.id)
				{
					l.clear();
					l.insert(l.end(), tttobj(id, "Q",
						string("ttt error: id mismatch at "+ThisPos).c_str()));
					break;
				}
				idset=true, id=i->obj.id;
				l.insert(l.end(), i->obj);
			}
		if(l.empty())
			l.insert(l.end(), tttobj(id, "Q",
				string("ttt error: no reply for "+ThisPos).c_str()));

		ThisPos=DoQuery(l).to;
	}
}
#undef tttcfull
#else
;
#endif
